-- CreateTable
CREATE TABLE "ColorPalette" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "name" TEXT,
    "type" TEXT,

    CONSTRAINT "ColorPalette_pkey" PRIMARY KEY ("id")
);

-- CreateTable
CREATE TABLE "ColorPaletteItem" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "tone" INTEGER,
    "hex" TEXT,
    "colorPaletteId" TEXT,

    CONSTRAINT "ColorPaletteItem_pkey" PRIMARY KEY ("id")
);

-- CreateTable
CREATE TABLE "_ImagePalettes" (
    "A" TEXT NOT NULL,
    "B" TEXT NOT NULL,

    CONSTRAINT "_ImagePalettes_AB_pkey" PRIMARY KEY ("A","B")
);

-- CreateIndex
CREATE INDEX "_ImagePalettes_B_index" ON "_ImagePalettes"("B");

-- AddForeignKey
ALTER TABLE "ColorPaletteItem" ADD CONSTRAINT "ColorPaletteItem_colorPaletteId_fkey" FOREIGN KEY ("colorPaletteId") REFERENCES "ColorPalette"("id") ON DELETE SET NULL ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "_ImagePalettes" ADD CONSTRAINT "_ImagePalettes_A_fkey" FOREIGN KEY ("A") REFERENCES "ColorPalette"("id") ON DELETE CASCADE ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "_ImagePalettes" ADD CONSTRAINT "_ImagePalettes_B_fkey" FOREIGN KEY ("B") REFERENCES "Image"("id") ON DELETE CASCADE ON UPDATE CASCADE;
