-- DropIndex
DROP INDEX "ImageMetadata_imageId_key";

-- DropIndex
DROP INDEX "ImageStats_imageId_key";

-- DropIndex
DROP INDEX "ImageVariant_imageId_key";

-- CreateTable
CREATE TABLE "ExtractColor" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "hex" TEXT NOT NULL,
    "imageId" TEXT NOT NULL,
    "blue" INTEGER NOT NULL,
    "green" INTEGER NOT NULL,
    "red" INTEGER NOT NULL,
    "isLight" BOOLEAN NOT NULL,
    "area" DOUBLE PRECISION,
    "hue" DOUBLE PRECISION,
    "saturation" DOUBLE PRECISION,
    "value" DOUBLE PRECISION,

    CONSTRAINT "ExtractColor_pkey" PRIMARY KEY ("id")
);

-- CreateTable
CREATE TABLE "ImageColor" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "imageId" TEXT NOT NULL,
    "type" TEXT NOT NULL,
    "hex" TEXT,
    "blue" INTEGER,
    "green" INTEGER,
    "red" INTEGER,

    CONSTRAINT "ImageColor_pkey" PRIMARY KEY ("id")
);

-- CreateTable
CREATE TABLE "ThemeSeed" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "imageId" TEXT NOT NULL,
    "seedHex" TEXT NOT NULL,

    CONSTRAINT "ThemeSeed_pkey" PRIMARY KEY ("id")
);

-- CreateTable
CREATE TABLE "PixelSummary" (
    "id" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL,
    "imageId" TEXT NOT NULL,
    "channels" INTEGER NOT NULL,
    "height" INTEGER NOT NULL,
    "width" INTEGER NOT NULL,

    CONSTRAINT "PixelSummary_pkey" PRIMARY KEY ("id")
);

-- AddForeignKey
ALTER TABLE "ExtractColor" ADD CONSTRAINT "ExtractColor_imageId_fkey" FOREIGN KEY ("imageId") REFERENCES "Image"("id") ON DELETE RESTRICT ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "ImageColor" ADD CONSTRAINT "ImageColor_imageId_fkey" FOREIGN KEY ("imageId") REFERENCES "Image"("id") ON DELETE RESTRICT ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "ThemeSeed" ADD CONSTRAINT "ThemeSeed_imageId_fkey" FOREIGN KEY ("imageId") REFERENCES "Image"("id") ON DELETE RESTRICT ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "PixelSummary" ADD CONSTRAINT "PixelSummary_imageId_fkey" FOREIGN KEY ("imageId") REFERENCES "Image"("id") ON DELETE RESTRICT ON UPDATE CASCADE;
