"use server"

import prisma from "@/lib/prisma";
import { artistSchema } from "@/schemas/artists/artistSchema";
import * as z from "zod/v4";

export async function createArtist(values: z.infer<typeof artistSchema>) {
  return await prisma.artist.create({
    data: {
      displayName: values.displayName,
      slug: values.slug,
      nickname: values.nickname,
      socials: {
        create: (values.socials || []).map((s) => ({
          platform: s.platform,
          handle: s.handle,
          link: s.link,
          isPrimary: s.isPrimary,
        })),
      },
    }
  })
}