"use server"

import prisma from "@/lib/prisma";
import { categorySchema } from "@/schemas/categories/categorySchema";
import * as z from "zod/v4";

export async function updateCategory(
  values: z.infer<typeof categorySchema>, 
  id: string
) {
  return await prisma.category.update({
    where: {
      id: id
    },
    data: {
      name: values.name,  
      description: values.description,
    }
  })
}