"use server"

import prisma from "@/lib/prisma";
import { tagSchema } from "@/schemas/tags/tagSchema";
import * as z from "zod/v4";

export async function updateTag(
  values: z.infer<typeof tagSchema>, 
  id: string
) {
  return await prisma.tag.update({
    where: {
      id: id
    },
    data: {
      name: values.name,  
      description: values.description,
    }
  })
}