import EditArtistForm from "@/components/artists/edit/EditArtistForm";
import prisma from "@/lib/prisma";

export default async function ArtistsEditPage({ params }: { params: { id: string } }) {
  const { id } = await params;

  const artist = await prisma.artist.findUnique({
    where: {
      id,
    },
    include: {
      socials: true
    }
  });

  return (
    <div>
      <h1 className="text-2xl font-bold mb-4">Edit album</h1>
      {artist ? <EditArtistForm artist={artist} /> : 'Artist not found...'}
    </div>
  );
}