import ListArtists from "@/components/artists/list/ListArtists";
import prisma from "@/lib/prisma";
import { PlusCircleIcon } from "lucide-react";
import Link from "next/link";

export default async function ArtistsPage() {
  const artists = await prisma.artist.findMany({
    orderBy: { createdAt: "asc" },
    include: { images: { select: { id: true } } }
  });

  return (
    <div>
      <div className="flex gap-4 justify-between">
        <h1 className="text-2xl font-bold mb-4">Artists</h1>
        <Link href="/artists/new" className="flex gap-2 items-center cursor-pointer bg-primary hover:bg-primary/90 text-primary-foreground px-4 py-2 rounded">
          <PlusCircleIcon className="h-[1.2rem] w-[1.2rem] scale-100 rotate-0 transition-all text-primary-foreground" /> Add new Artist
        </Link>
      </div>
      {artists.length > 0 ? <ListArtists artists={artists} /> : <p className="text-muted-foreground italic">No artists found.</p>}
    </div>
  );
}