import EditCategoryForm from "@/components/categories/edit/EditCategoryForm";
import prisma from "@/lib/prisma";

export default async function CategoriesEditPage({ params }: { params: { id: string } }) {
  const { id } = await params;

  const cat = await prisma.category.findUnique({
    where: {
      id,
    }
  });

  return (
    <div>
      <h1 className="text-2xl font-bold mb-4">Edit category</h1>
      {cat ? <EditCategoryForm category={cat} /> : 'Category not found...'}
    </div>
  );
}