import ListCategories from "@/components/categories/list/ListCategories";
import prisma from "@/lib/prisma";
import { PlusCircleIcon } from "lucide-react";
import Link from "next/link";

export default async function CategoriesPage() {
  const categories = await prisma.category.findMany(
    {
      orderBy: { createdAt: "asc" },
      include: { images: { select: { id: true } } }
    }
  );

  return (
    <div>
      <div className="flex gap-4 justify-between">
        <h1 className="text-2xl font-bold mb-4">Categories</h1>
        <Link href="/categories/new" className="flex gap-2 items-center cursor-pointer bg-primary hover:bg-primary/90 text-primary-foreground px-4 py-2 rounded">
          <PlusCircleIcon className="h-[1.2rem] w-[1.2rem] scale-100 rotate-0 transition-all text-primary-foreground" /> Add new Category
        </Link>
      </div>
      {categories.length > 0 ? <ListCategories categories={categories} /> : <p className="text-muted-foreground italic">No categories found.</p>}
    </div>
  );
}