import DisplayPalette from "@/components/palettes/single/DisplayPalette";
import prisma from "@/lib/prisma";

export default async function PalettesPage({ params }: { params: { id: string } }) {
  const { id } = await params;

  const palette = await prisma.colorPalette.findUnique({
    where: {
      id,
    },
    include: {
      items: true,
      images: {
        include: {
          image: {
            include: {
              variants: { where: { type: "thumbnail" } }
            }
          }
        }
      }
    }
  });

  return (
    <div>
      <h1 className="text-2xl font-bold mb-4">Show palette</h1>
      {palette ? <DisplayPalette palette={palette} /> : 'Palette not found...'}
    </div>
  );
}