import ListPalettes from "@/components/palettes/list/ListPalettes";
import prisma from "@/lib/prisma";

export default async function PalettesPage() {
  const palettes = await prisma.colorPalette.findMany(
    {
      orderBy: { name: "asc" },
      include: {
        items: true,
        images: { select: { id: true } }
      }
    }
  );

  return (
    <div>
      <div className="flex gap-4 justify-between">
        <h1 className="text-2xl font-bold mb-4">Palettes</h1>
      </div>
      {palettes.length > 0 ? <ListPalettes palettes={palettes} /> : <p className="text-muted-foreground italic">No palettes found.</p>}
    </div>
  );
}