import EditTagForm from "@/components/tags/edit/EditTagForm";
import prisma from "@/lib/prisma";

export default async function TagsEditPage({ params }: { params: { id: string } }) {
  const { id } = await params;

  const tag = await prisma.tag.findUnique({
    where: {
      id,
    }
  });

  return (
    <div>
      <h1 className="text-2xl font-bold mb-4">Edit tag</h1>
      {tag ? <EditTagForm tag={tag} /> : 'Tag not found...'}
    </div>
  );
}