import ListTags from "@/components/tags/list/ListTags";
import prisma from "@/lib/prisma";
import { PlusCircleIcon } from "lucide-react";
import Link from "next/link";

export default async function TagsPage() {
  const tags = await prisma.tag.findMany(
    {
      orderBy: { createdAt: "asc" }
    }
  );

  return (
    <div>
      <div className="flex gap-4 justify-between">
        <h1 className="text-2xl font-bold mb-4">Tags</h1>
        <Link href="/tags/new" className="flex gap-2 items-center cursor-pointer bg-primary hover:bg-primary/90 text-primary-foreground px-4 py-2 rounded">
          <PlusCircleIcon className="h-[1.2rem] w-[1.2rem] scale-100 rotate-0 transition-all text-primary-foreground" /> Add new Tag
        </Link>
      </div>
      {tags.length > 0 ? <ListTags tags={tags} /> : <p className="text-muted-foreground italic">No tags found.</p>}
    </div>
  );
}