import { Card, CardContent, CardFooter, CardHeader, CardTitle } from "@/components/ui/card";
import { Artist } from "@/generated/prisma";
import Link from "next/link";

type ArtistsWithItems = Artist & {
  images: { id: string }[]
}

export default function ListArtists({ artists }: { artists: ArtistsWithItems[] }) {
  return (
    <div className="grid gap-6 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4">
      {artists.map((artist) => (
        <Link href={`/artists/edit/${artist.id}`} key={artist.id}>
          <Card className="overflow-hidden">
            <CardHeader>
              <CardTitle className="text-base truncate">{artist.displayName}</CardTitle>
            </CardHeader>
            <CardContent>
            </CardContent>
            <CardFooter>
              Connected to {artist.images.length} image{artist.images.length !== 1 ? "s" : ""}
            </CardFooter>
          </Card>
        </Link>
      ))}
    </div>
  );
}