"use client"

import { deleteImage } from "@/actions/images/deleteImage";
import { Button } from "@/components/ui/button";
import { useRouter } from "next/navigation";

export default function DeleteImageButton({ imageId }: { imageId: string }) {
  const router = useRouter();

  async function handleDelete() {
    if (confirm("Are you sure you want to delete this image? This action is irreversible.")) {
      const result = await deleteImage(imageId);
      if (result?.success) {
        router.push("/images"); // redirect to image list or gallery
      } else {
        alert("Failed to delete image.");
      }
    }
  }

  return (
    <Button variant="destructive" onClick={handleDelete}>
      Delete Image
    </Button>
  );
}