// "use client"

import { Card, CardContent, CardHeader, CardTitle } from "@/components/ui/card";
import { Image } from "@/generated/prisma";
import NetImage from "next/image";
import Link from "next/link";

export default function ListImages({ images }: { images: Image[] }) {
  return (
    <div className="grid gap-6 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4">
      {images.map((image) => (
        <Link href={`/images/edit/${image.id}`} key={image.id}>
          <Card className="overflow-hidden">
            <CardHeader>
              <CardTitle className="text-base truncate">{image.imageName}</CardTitle>
            </CardHeader>
            <CardContent>
              <NetImage src={`/api/image/thumbnails/${image.fileKey}.webp`} alt={image.altText ? image.altText : "Image"} width={200} height={200} />
            </CardContent>
          </Card>
        </Link>
      ))}
    </div>
  );
}