import { Card, CardContent, CardFooter, CardHeader, CardTitle } from "@/components/ui/card";
import { Tag } from "@/generated/prisma";
import Link from "next/link";

export default function ListTags({ tags }: { tags: Tag[] }) {
  return (
    <div className="grid gap-6 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4">
      {tags.map((tag) => (
        <Link href={`/tags/edit/${tag.id}`} key={tag.id}>
          <Card className="overflow-hidden">
            <CardHeader>
              <CardTitle className="text-base truncate">{tag.name}</CardTitle>
            </CardHeader>
            <CardContent>
              {tag.description && <p className="text-sm text-muted-foreground">{tag.description}</p>}
            </CardContent>
            <CardFooter>
            </CardFooter>
          </Card>
        </Link>
      ))}
    </div>
  );
}