import { s3 } from "@/lib/s3";
import { GetObjectCommand } from "@aws-sdk/client-s3";
import { Readable } from "stream";

export async function getImageBufferFromS3(fileKey: string): Promise<Buffer> {
  const command = new GetObjectCommand({
    Bucket: "felliesartapp",
    Key: `original/${fileKey}.webp`,
  });

  const response = await s3.send(command);
  const stream = response.Body as Readable;

  const chunks: Uint8Array[] = [];
  for await (const chunk of stream) {
    chunks.push(chunk);
  }

  return Buffer.concat(chunks);
}